program test
! JMA ٥ȥȥåǡ calc_TCenter Ѥߥǡ
! RMSE ׻.
! ǡԤοΤϰۤʤäƤƤ褤.
! RMSE ϥ٥ȥȥåǡͤȤƷ׻Τ,
! ٥ȥȥåȴƱΥǥ̤ΥǡΤ
! Ӥ˻Ѥ (ʳλ郎ޤޤƤƤʤ).
! ޤ, ٥ȥȥå˳ǼƤ˥ǥ̤
! ʤǤ, λΥ٥ȥȥåǡϻѤʤǤ.
! (顼ˤϤʤʤ.)
! ǡեޥåȤ dcl_draw_calc_region Υȥåɤ߹ߤƱ.
! Ĥޤ, 1 ܤ
! , ,  (YYYYMMDDHH) ν 3 Ѱդ.
! ʸӤѤ.

  use Basis
  use File_Operate
  use Math_const
  use Phys_Const
  use map_function

  implicit none

  integer, parameter :: skip=2, nx=1, ny=2, nt=3, np=4, nv=5
  integer :: i, j, k, nobs, nsim, counter, nr
  real :: rmse, unitfact
  double precision :: coe
  double precision, parameter :: undef=-999.0d0
  double precision, allocatable, dimension(:) :: obsx, obsy, simx, simy
  real, allocatable, dimension(:) :: obsp, obsv, simp, simv, rad
  character(100) :: obstime, simtime
  character(100), allocatable, dimension(:,:) :: cobs, csim
  character(1000) :: obsname, simname, unitname
  character(1) :: calc_flag

  write(*,*) "Input Obs data and Sim data."
  read(*,*) obsname, simname
  write(*,*) "Input parameter [T=track, P=CP, V=vmax]"
  read(*,*) calc_flag

  coe=pi_dp/180.0d0

  nobs=line_number_counter( trim(obsname) )-skip
  nsim=line_number_counter( trim(simname) )-skip

  select case (calc_flag(1:1))
  case ('T')  ! track
     nr=nt
     unitfact=1.0e-3
     unitname='km'
  case ('P')  ! central pressure
     nr=np
     unitfact=1.0e0
     unitname='hPa'
  case ('V')  ! vmax
     nr=nv
     unitfact=1.0e0
     unitname='ms-1'
  end select

  allocate(cobs(nr,nobs))
  allocate(csim(nr,nsim))

  call read_file_text( trim(obsname), nr, nobs, cobs, skip=skip )
  call read_file_text( trim(simname), nr, nsim, csim, skip=skip )

  allocate(obsx(nobs))
  allocate(obsy(nobs))
  allocate(obsp(nobs))
  allocate(obsv(nobs))
  allocate(simx(nobs))
  allocate(simy(nobs))
  allocate(simp(nobs))
  allocate(simv(nobs))
  allocate(rad(nobs))

  simx=undef
  simy=undef
  simp=real(undef)
  simv=real(undef)
  rad=real(undef)

  do i=1,nobs
     obstime=trim(adjustl(cobs(nt,i)))

     select case (calc_flag(1:1))
     case ('T')
        obsx(i)=dble(c2r_convert( trim(adjustl(cobs(nx,i))) ))*coe
        obsy(i)=dble(c2r_convert( trim(adjustl(cobs(ny,i))) ))*coe
     case ('P')
        obsp(i)=c2r_convert( trim(adjustl(cobs(np,i))) )
     case ('V')
        obsv(i)=c2r_convert( trim(adjustl(cobs(nv,i))) )
     end select

     do j=1,nsim
        simtime=trim(adjustl(csim(nt,j)))
        if(obstime(1:10)==simtime(1:10))then
           select case (calc_flag)
           case ('T')
              simx(i)=dble(c2r_convert( trim(adjustl(csim(nx,j))) ))*coe
              simy(i)=dble(c2r_convert( trim(adjustl(csim(ny,j))) ))*coe
           case ('P')
              simp(i)=c2r_convert( trim(adjustl(csim(np,j))) )
           case ('V')
              simv(i)=c2r_convert( trim(adjustl(csim(nv,j))) )
           end select
           exit
        end if
     end do

     select case (calc_flag(1:1))
     case ('T')
        if(simx(i)/=undef.and.simy(i)/=undef)then
           rad(i)=real(ll2radi( obsx(i), obsy(i), simx(i), simy(i) ))
           rad(i)=rad(i)**2
        end if
     case ('P')
        if(simp(i)/=real(undef))then
           rad(i)=abs(obsp(i)-simp(i))**2
        end if
     case ('V')
        if(simv(i)/=real(undef))then
           rad(i)=abs(obsv(i)-simv(i))**2
        end if
     end select
  end do

!-- Calculating RMSE.

  rmse=0.0e0
  counter=0
  do i=1,nobs
     if(rad(i)/=undef)then
        rmse=rmse+rad(i)
        counter=counter+1
     end if
  end do
  rmse=sqrt(rmse/real(counter))

  write(*,*) "----------------------------"
  write(*,*) "RMSE = ", real(rmse)*unitfact, trim(adjustl(unitname))//"."
  write(*,*) "----------------------------"

end program
