module dcl_draw_calc_region_sub

contains

subroutine namelist_read( draw_flag, mpopt, xdim, ydim, dx, dy, ulon, ulat,  &
  &                       ri, rj, tlon, tlat1, tlat2, IWS )
  implicit none

  integer :: IWS
  integer, dimension(5) :: mpopt, xdim, ydim
  real, dimension(5) :: dx, dy, ulon, ulat, ri, rj, tlon, tlat1, tlat2
  character(5) :: draw_flag

  namelist /domain/ draw_flag, mpopt, xdim, ydim, dx, dy, ulon, ulat,  &
  &                 ri, rj, tlon, tlat1, tlat2, IWS
  read(5,nml=domain)

end subroutine namelist_read


subroutine calc_mp( mpopt, xdim, ydim, dx, dy,  &
  &                 ulon, ulat, ri, rj,  &
  &                 tlon, tlat1, tlat2, valx, valy )
  implicit none
  integer :: mpopt   ! Ͽ޺ɸ [0=ٷ, 2=٥, 3=륫ȥ]
  integer :: xdim    ! x γʻ
  integer :: ydim    ! y γʻ
  real    :: dx      ! x γʻҴֳ [m or degree]
  real    :: dy      ! y γʻҴֳ [m or degree]
  real    :: ulon    ! x δɸ [degree]
  real    :: ulat    ! y δɸ [degree]
  real    :: ri      ! x δɸбʻֹ
  real    :: rj      ! y δɸбʻֹ
  real    :: tlon    ! x Ͽޤɸɸ [degree]
  real    :: tlat1   ! y Ͽޤɸɸ 1 [degree]
  real    :: tlat2   ! y Ͽޤɸɸ 2 [degree]
  real    :: valx(5) ! x ˷׻ɸ 4  [degree]
  real    :: valy(5) ! y ˷׻ɸ 4  [degree]

  real, parameter :: re=6370.0e3   ! ϵȾ [m]
  real, parameter :: pi=3.14159    ! ߼Ψ

  integer :: i
  real :: ux, uy
  real, dimension(5) :: tmpx, tmpy

  select case (mpopt)
  case (0)  ! ٷ
     valx(1)=ulon+dx*real(1-int(ri))
     valx(2)=ulon+dx*real(xdim-int(ri))
     valx(3)=valx(2)
     valx(4)=valx(1)

     valy(1)=ulat+dy*real(1-int(rj))
     valy(2)=valy(1)
     valy(3)=ulat+dy*real(ydim-int(rj))
     valy(4)=valy(3)

  case (2)  ! ٥ (ɸɸɸ x, y ͤФ, ɸɸ˰ư.)
     valx(1)=dx*real(1-int(ri))
     valx(2)=dx*real(xdim-int(ri))
     valx(3)=valx(2)
     valx(4)=valx(1)
     valx(5)=valx(1)

     valy(1)=dy*real(1-int(rj))
     valy(3)=dy*real(ydim-int(rj))
     valy(2)=valy(1)
     valy(4)=valy(3)
     valy(5)=valy(1)

     !-- ޤ, ɸɸȤɸ x,y ɸФ.
     call lambert_ll2xy( ulon, ulat, tlon, tlat1, tlat2, ux, uy )

     !-- valx, valy ˤĤ, ɸɸʿ԰ư.
     do i=1,5
        valx(i)=valx(i)+ux
        valy(i)=valy(i)+uy
     end do

     !--  valx, valy ˤĤ, ٷ٤Ѵ.
     do i=1,5
        call lambert_xy2ll( valx(i), valy(i), tlon, tlat1, tlat2, tmpx(i), tmpy(i) )
        valx(i)=tmpx(i)
        valy(i)=tmpy(i)
     end do

  case (3)  ! 륫ȥ
     ulon=ulon*pi/180.0
     ulat=ulat*pi/180.0
     tlon=tlon*pi/180.0
     tlat1=tlat1*pi/180.0
     tlat2=tlat2*pi/180.0

     valx(1)=dx*real(1-int(ri))
     valx(2)=dx*real(xdim-int(ri))
     valx(1)=valx(1)/(re*cos(ulat))+ulon
     valx(2)=valx(2)/(re*cos(ulat))+ulon
     valx(1)=valx(1)*180.0/pi
     valx(2)=valx(2)*180.0/pi
     valx(3)=valx(2)
     valx(4)=valx(1)

     valy(1)=dy*real(1-int(rj))
     valy(3)=dy*real(ydim-int(rj))
     valy(1)=valy(1)/re+ulat
     valy(3)=valy(3)/re+ulat
     valy(1)=valy(1)*180.0/pi
     valy(3)=valy(3)*180.0/pi
     valy(2)=valy(1)
     valy(4)=valy(3)

  end select

  valx(5)=valx(1)
  valy(5)=valy(1)

end subroutine calc_mp


subroutine lambert_ll2xy( lon, lat, tlon, tlat1, tlat2, x, y )
  implicit none
  real :: lon     ! Ѵ [degree]
  real :: lat     ! Ѵ [degree]
  real :: tlon    ! ɸ [degree]
  real :: tlat1   ! ɸ 1 [degree]
  real :: tlat2   ! ɸ 2 [degree]
  real :: x       ! Ѵ줿 x ɸ [m]
  real :: y       ! Ѵ줿 y ɸ [m]
  real, parameter :: re=6370.0e3  ! ϵȾ [m]
  real, parameter :: pi=3.14159   ! ߼Ψ
  real :: llon, llat, tl1, tl2, tl0, coe, rs, rs0

  tl0=tlon*pi/180.0
  tl1=tlat1*pi/180.0
  tl2=tlat2*pi/180.0
  llon=lon*pi/180.0
  llat=lat*pi/180.0

  coe=(log(cos(tl1)/cos(tl2)))/(gdi(tl2)-gdi(tl1))
  rs=exp(coe*(gdi(tl1)-gdi(llat)))*cos(tl1)/coe
  rs0=cos(tl1)/coe

  x=re*rs*sin(coe*(llon-tl0))
  y=re*(rs0-rs*cos(coe*(llon-tl0)))

end subroutine lambert_ll2xy


subroutine lambert_xy2ll( x, y, tlon, tlat1, tlat2, lon, lat )
  implicit none
  real :: x       ! Ѵ x ɸ [m]
  real :: y       ! Ѵ y ɸ [m]
  real :: tlon    ! ɸ [degree]
  real :: tlat1   ! ɸ 1 [degree]
  real :: tlat2   ! ɸ 2 [degree]
  real :: lon     ! Ѵ줿 [degree]
  real :: lat     ! Ѵ줿 [degree]
  real, parameter :: re=6370.0e3  ! ϵȾ [m]
  real, parameter :: pi=3.14159   ! ߼Ψ
  real :: llon, llat, tl1, tl2, tl0, coe, rs, rs0, tmp1

  tl0=tlon*pi/180.0
  tl1=tlat1*pi/180.0
  tl2=tlat2*pi/180.0

  coe=(log(cos(tl1)/cos(tl2)))/(gdi(tl2)-gdi(tl1))
  rs0=cos(tl1)/coe
  rs=sqrt((x/re)**2+(y/re-rs0)**2)
  tmp1=gdi(tl1)-log(rs*coe/cos(tl1))/coe

  llon=tl0+(asin(x/(re*rs)))/coe
  llat=atan(sinh(tmp1))

  lon=llon*180.0/pi
  lat=llat*180.0/pi

  return
end subroutine lambert_xy2ll


real function gd( x )  ! ǥޥؿ
  implicit none
  real :: x
  real, parameter :: pi=3.14159

  gd=2.0*atan(exp(x))-0.5*pi

  return
end function gd


real function gdi( x )  ! ǥޥմؿ
  implicit none
  real :: x
  real, parameter :: pi=3.14159

  gdi=log(abs(tan(0.25*pi+0.5*x)))

  return
end function gdi


end module dcl_draw_calc_region_sub
