#!/bin/bash

export RUBYLIB=$RUBYLIB:/home/satoki/usr/local/ruby/lib
ulimit -s unlimited

cd /home/satoki/work/developping/zatta/gpv_convert
dir=/home/satoki/usr/local/bin

yyyy=`date +"%Y" --date "1 day ago"`
mmmm=`date +"%m" --date "1 day ago"`
dddd=`date +"%d" --date "1 day ago"`
date_=`date +"%Y%m%d" --date "1 day ago"`

#-- data downloading
$dir/auto_downloader.rb $yyyy $mmmm $dddd $dddd 2 p
$dir/auto_downloader.rb $yyyy $mmmm $dddd $dddd 2 s
$dir/auto_downloader.rb $yyyy $mmmm $dddd $dddd 1

#-- extracting GRIB2 data
for i in Z__C_RJTD_*L-pall*.bin
do
  $dir/wgrib2 $i | grep "0 mb:anl:\|5 mb:anl:" | $dir/wgrib2 -i $i -no_header -ieee $i.dat
done

for i in Z__C_RJTD_*Lsurf*.bin
do
  $dir/wgrib2 $i | grep ":anl:" | $dir/wgrib2 -i $i -no_header -ieee $i.dat
done

for i in Z__C_RJTD_*GSM*.bin
do
  $dir/wgrib2 $i | grep "0 mb:anl:\|5 mb:anl:" | $dir/wgrib2 -i $i -no_header -ieee $i.dat
done

#-- Adding files to list file
ls Z__C_RJTD_*pall*.dat > msm_upper_list.dat
ls Z__C_RJTD_*Lsurf*.dat > msm_surf_list.dat
ls Z__C_RJTD_*GSM*.dat > gsm_upper_list.dat

#-- Converting GRIB2 to GrADS
./gpv_convert < gpv_convert_MSM_sfc.nml 
./gpv_convert < gpv_convert_GSM_nosfc.nml 

#-- Adding files to list file
ls Z__C_RJTD_*MSM*.out > tmp_msm_list.dat
ls Z__C_RJTD_*GSM*.out > tmp_gsm_list.dat

#-- Editing list file
ruby rewrite.rb tmp_msm_list.dat msm_list.dat
ruby rewrite.rb tmp_gsm_list.dat gsm_list.dat

#-- Drawing figures
ruby draw_MSM.rb msm_list.dat
ruby draw_GSM.rb gsm_list.dat

#-- Converting figures
for i in *.eps
do
   convert -density 200 $i ${i%.eps}.png
done

#-- Removing data
rm Z__*
rm *.eps

#-- Moving figures to public_html
mkdir ~/public_html/main/tmp/figure/$date_
mv *.png ~/public_html/main/tmp/figure/$date_/
