program conv_ter

  use file_operate  ! /home/satoki/usr/local/lib/libstpk.a

  implicit none

  integer, parameter :: nx=288, ny=145
  real, parameter :: g0=9.80665  ! From JRA55 manual.

  integer :: i, j
  real, dimension(nx,ny) :: val, rval, lval
  character(1000) :: fname, lname

  write(*,*) "Input converting file name."
  read(*,*) fname
  write(*,*) "Input referring land-use file name."
  read(*,*) lname

  call read_file( trim(adjustl(fname)), nx, ny, 1, val )
  call read_file( trim(adjustl(lname)), nx, ny, 1, lval )

  do j=1,ny
     do i=1,nx
!        rval(i,j)=val(i,ny-j+1)
        rval(i,j)=val(i,j)
        if(lval(i,j)==0.0)then
           rval(i,j)=-0.01
        else
           rval(i,j)=rval(i,j)/g0
        end if
     end do
  end do

  call write_file( trim(adjustl(fname))//'.out', nx, ny, 1, rval, mode='replace' )

  write(*,*) "Finish."

end program
