program couple_rev

  use Basis
  use file_operate

  implicit none

  integer, parameter :: nx=288, ny=145, nz=37, nzrh=27
  integer :: i, j, k, l
  real, dimension(nx,ny,nz) :: val, rval
  character(1000) :: oname
  character(1000), allocatable, dimension(:) :: iname
  integer, external :: iargc
  integer :: nargc

  nargc=iargc()

  if(nargc==0)then
     write(*,*) "[USAGE] : ./couple_rev iname1 .. inamen iname27 oname"
     write(*,*) "          iname27 == water vapor (rh, depr, spfh)"
     stop
  end if

  allocate(iname(nargc-1))

  do i=1,nargc-1
     call getarg(i,iname(i))
  end do
  call getarg(nargc,oname)

  write(*,*) "*** MESSAGE (main:from) ***"
  do i=1,nargc-1
     write(*,*) "iname"//trim(adjustl(i2c_convert(i)))  &
  &           //" = "//trim(adjustl(iname(i)))
  end do
  write(*,*) "oname = "//trim(adjustl(oname))
  write(*,*) "*** MESSAGE (main:to) ***"

  do l=1,nargc-2
     call read_file_3d( trim(adjustl(iname(l))), nx, ny, nz, 1, val )
     do k=1,nz
        do j=1,ny
           do i=1,nx
!              rval(i,j,k)=val(i,j,nz-k+1)
              rval(i,j,k)=val(i,ny-j+1,nz-k+1)
           end do
        end do
     end do
     if(l==1)then
        call write_file_3d( trim(adjustl(oname)), nx, ny, nz, (l-1)*nz+1,  &
  &                         rval, mode='replace' )
     else
        call write_file_3d( trim(adjustl(oname)), nx, ny, nz, (l-1)*nz+1,  &
  &                         rval, mode='old' )
     end if
  end do

  call read_file_3d( trim(adjustl(iname(l))), nx, ny, nzrh, 1,  &
  &                  val(1:nx,1:ny,1:nzrh) )

  do k=1,nzrh
     do j=1,ny
        do i=1,nx
!           rval(i,j,k)=val(i,j,nzrh-k+1)
           rval(i,j,k)=val(i,ny-j+1,nzrh-k+1)
        end do
     end do
  end do

  l=nargc-1
  call write_file_3d( trim(adjustl(oname)), nx, ny, nzrh, (l-1)*nz+1,  &
  &                   rval(1:nx,1:ny,1:nzrh), mode='old' )

  write(*,*) "Finish : "//trim(adjustl(oname))//'.'

end program
