program couple_rev

  use Basis
  use file_operate

  implicit none

  integer, parameter :: nx=288, ny=145, nz=9
  integer :: i, j, k, l
  real, dimension(nx,ny,nz) :: val, rval
  character(1000) :: oname
  character(1000), allocatable, dimension(:) :: iname
  integer, external :: iargc
  integer :: nargc

  nargc=iargc()

  if(nargc==0)then
     write(*,*) "[USAGE] : ./couple_rev_surf iname oname"
     stop
  end if

  allocate(iname(nargc-1))

  do i=1,nargc-1
     call getarg(i,iname(i))
  end do
  call getarg(nargc,oname)

  write(*,*) "*** MESSAGE (main:from) ***"
  do i=1,nargc-1
     write(*,*) "iname"//trim(adjustl(i2c_convert(i)))  &
  &           //" = "//trim(adjustl(iname(i)))
  end do
  write(*,*) "oname = "//trim(adjustl(oname))
  write(*,*) "*** MESSAGE (main:to) ***"

  call read_file_3d( trim(adjustl(iname(1))), nx, ny, nz, 1, val )

  do k=1,nz
     do j=1,ny
        do i=1,nx
!           rval(i,j,k)=val(i,j,k)
           rval(i,j,k)=val(i,ny-j+1,k)
        end do
     end do
  end do

  call write_file_3d( trim(adjustl(oname)), nx, ny, nz, 1,  &
  &                   rval, mode='replace' )

  write(*,*) "Finish : "//trim(adjustl(oname))//'.'

end program
