program read_mgdsst_nc
  ! mgdsst Υꥸʥǡ GrADS or NetCDF Ѵץ
  ! sst_list ˺ǡե񤭹, ưǺ.

  use file_operate

  implicit none
  integer, parameter :: nx=1440  ! mgdsst longtitude
  integer, parameter :: ny=720   ! mgdsst latitude
  real, parameter :: dlon=0.25  ! resolution of longtitude
  real, parameter :: dlat=0.25  ! resolution of latitude
  real, parameter :: lonmin=0.125  ! data start point (long)
  real, parameter :: latmin=-89.875  ! data start point (lat)
  real, parameter :: undef=999.0, undefc=-1.0e35
  real, dimension(nx,ny) :: sst
  real :: lon(nx), lat(ny)
  character(80), parameter :: dat_name='sst_list'
  character(80), allocatable, dimension(:) :: dat_list
  integer :: dat_line
  character(10) :: formatt
  integer :: i, j, k, dtype
  real, parameter :: cmin=270.0, cmax=306.0, contmin=270.0, contmax=306.0
  real, parameter :: vxmin=0.15, vxmax=0.85, vymin=0.225, vymax=0.775

  lon=(/((lonmin+dlon*(i-1)),i=1,nx)/)
  lat=(/((latmin+dlat*(i-1)),i=1,ny)/)

  formatt='(1440a3)'
  dat_line=line_number_counter( trim(dat_name) )
  allocate(dat_list(dat_line))
  call read_file_text( trim(dat_name), 1, dat_line, dat_list )

  write(*,'(a26,1PE14.5,a2,1PE14.5,a3)') "Undef value is converting ",  &
  &                                      undef, '->', undefc, '...'

  do i=1,dat_line
     call read_mgdsst( trim(dat_list(i)), sst )  ! ɤ߹

     do j=1,ny
        do k=1,nx
           if(sst(k,j)==undef)then
              sst(k,j)=undefc
           end if
        end do
     end do

     call write_file( trim(dat_list(i))//'.bin', nx, ny, 1,  &
  &                   sst, mode='replace' )
     write(*,*) "Finish : "//trim(dat_list(i))//'.bin'

  end do

end program
